//
// HexToMch -> conversion fichier .hex vers fichier .mch table MPLABX    23/05/2023
//
// syntaxe: HexToMch fic.hex

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

main(int argc, char **argv) 
{
  char frname[1000], fwname[1000]; FILE *fr, *fw; 
  char buf[200], out[200]; int n=0, nblig=0, err=0; char* s;

  if (argc == 3) { 
    strcpy(frname, argv[2]); strlwr(frname); 
    if (! (atoi(argv[1]) % 8)) n = atoi(argv[1])/8;
  }
  if (argc != 3 || n < 1 || n > 32 ||
    strlen(frname) < 5 || strcmp(frname+strlen(frname)-4, ".hex"))  {
    printf("\nConversion fichier HEX vers table MCH MPLABX"); 
    printf("\nTraite des mots de taille n = 8, 16, 24 ou 32 bits"); 
    printf("\nSyntaxe : HexToMch n fic.hex\n"); exit(1); 
  }
  s = strrchr(frname, '\\');
  strcpy(fwname, s ? s+1 : frname);
  strcpy(fwname+strlen(fwname)-3, "mch");
  
  fr = fopen(frname, "rb");
  if (!fr) { printf("\nErreur: fopen read !\n"); exit(1); }
  fw = fopen(fwname, "wb");
  if (!fw) { printf("\nErreur: fopen write !\n"); exit(1); }

  while (!err) {
    int i, j, l=0; char *cr, *lf; 
    i = fread(buf, 1, 100, fr); if (i <= 0) break;
    buf[i] = 0;
    cr = strchr(buf, 13); lf = strchr(buf, 10);
    if (!cr || (lf && lf == cr+1)) {
      if (!cr && !lf) l = i;
      else l = lf-buf - (cr != 0);
      if (fseek(fr, l-i + (cr == 0 ? 1 : 2), SEEK_CUR)) {
        err = 1; strcpy(buf, "fseek incorrect"); 
      }
      else if (l == 43) {
        char *p=buf+9, *q=out; nblig++;
        i = 16/n; while (i--) {
          j = 2*n; while (j--) *q++ = *p++; 
          *q++ = 9; 
        }
        *q++ = 13; *q++ = 10; 
        *q = 0;
        if (fwrite(out, 1, strlen(out), fw) != strlen(out)) {
          err = 1; strcpy(buf, "fwrite incorrect"); 
        }
      }
    }
  }
  if (err) printf("\nErreur : %s !\n", buf);
  else printf("\nFichier %s contenant une table MPLABX de %u octets.\n", fwname, nblig*16);
  fclose(fr); fclose(fw);
  exit(0);
}
